import { SCIMUser } from "../../scim/User";
import { Context } from "../Context";
import { handleRcError } from "./endpoint";

export async function findOrCreateRole(
    ctx: Context,
    user: SCIMUser,
): Promise<Array<string>> {
    const listResp = await ctx.rc.role.list();
    handleRcError(listResp);
    const rcRoles = listResp.roles;
    const roles = await Promise.all(
        user.roles.map(async ({ value }) => {
            let rcRole = rcRoles.find((x) => x.name === value);
            if (!rcRole) {
                const r = await ctx.rc.role.create({ name: value });
                handleRcError(r);
                rcRoles.push(r.role);
                rcRole = r.role;
            }
            return rcRole._id;
        }),
    );
    return roles;
}
