import { HttpStatusCode } from "@rocket.chat/apps-engine/definition/accessors";
import { SCIMError, SCIMErrorType } from "../scim/Error";
import { BaseError } from "./BaseError";

export class EmptyRequestError extends BaseError {
    public message = "Request body is empty or content type is unsupported";
    public toSCIMError(): SCIMError {
        return new SCIMError()
            .setStatus(HttpStatusCode.BAD_REQUEST)
            .setScimType(SCIMErrorType.INVALID_VALUE)
            .setDetail(this.message);
    }
}
