import { HttpStatusCode } from "@rocket.chat/apps-engine/definition/accessors";
import { SCIMError, SCIMErrorType } from "../scim/Error";
import { BaseError } from "./BaseError";

export class EmptyResponseError extends BaseError {
    public message = "Rocket.Chat API returned an empty response";
    public toSCIMError(): SCIMError {
        return new SCIMError()
            .setStatus(HttpStatusCode.INTERNAL_SERVER_ERROR)
            .setScimType(SCIMErrorType.INVALID_VALUE)
            .setDetail(this.message);
    }
}
