import { RcSdk } from "./RcSdk";

interface IRoleCreate {
    name: string;
    scope?: string;
    description?: boolean;
}

export interface IRole {
    _id: string;
    name: string;
    scope?: string;
    description?: boolean;
    createdAt: string;
    _updatedAt?: string;
}

interface IRoleListResponse {
    roles: Array<IRole>;
    count: number;
    success: boolean;
    error?: string;
}

interface IRoleResponse {
    role: IRole;
    success: boolean;
    error?: string;
}

export class RcSdkRole {
    private sdk: RcSdk;
    constructor(sdk: RcSdk) {
        this.sdk = sdk;
    }

    public list(): Promise<IRoleListResponse> {
        return this.sdk.get(`roles.list`);
    }

    public create(body: IRoleCreate): Promise<IRoleResponse> {
        return this.sdk.post(`roles.create`, body);
    }
}
